/*######     Copyright (c) 1997-2014 Ufasoft  http://ufasoft.com  mailto:support@ufasoft.com,  Sergey Pavlov  mailto:dev@ufasoft.com #########################################################################################################
#                                                                                                                                                                                                                                            #
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation;  either version 3, or (at your option) any later version.          #
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.   #
# You should have received a copy of the GNU General Public License along with this program; If not, see <http://www.gnu.org/licenses/>                                                                                                      #
############################################################################################################################################################################################################################################*/

#pragma once

#if !defined(DEBUG) && defined(_DEBUG)
#	define DEBUG 1
#endif

#ifdef _DEBUG
#	define UCFG_DEBUG 1
#else
#	define UCFG_DEBUG 0
#endif

#ifdef _PROFILE
#	define UCFG_PROFILE 1
#else
#	define UCFG_PROFILE 0
#endif

#ifndef _WIN32_IE
#	define _WIN32_IE 0x500
#endif

#ifdef _WIN32
#	define  NTDDI_WINLH NTDDI_VISTA				//!!! not defined in current SDK
#endif

#ifndef _MSC_VER
#	ifdef __x86_64__
#		define _M_X64
#	elif defined(__i786__)
#		define _M_IX86 700
#	elif defined(__i686__)
#		define _M_IX86 600
#	elif defined(__i586__)
#		define _M_IX86 500
#	elif defined(__i486__)
#		define _M_IX86 400
#	elif defined(__i386__)
#		define _M_IX86 300
#	elif defined(__arm__)
#		define _M_ARM
#	elif defined(__mips__)
#		define _M_MIPS
#	endif	

#	ifdef __SSE2__
#		define _M_IX86_FP 2
#	endif
#endif  // ndef _MSC_VER

#if defined(__GNUC__) && __GNUC__ > 0 && !defined(__clang__)
#	define UCFG_GNUC_VERSION (__GNUC__ * 100 + __GNUC_MINOR__)
#else
#	define UCFG_GNUC_VERSION 0
#endif

#ifdef __clang__
#	define UCFG_CLANG_VERSION (__clang_major__ * 100 + __clang_minor__)
#else
#	define UCFG_CLANG_VERSION 0
#endif

#ifdef _MSC_VER
#	define UCFG_MSC_VERSION _MSC_VER
#	define UCFG_MSC_FULL_VERSION _MSC_FULL_VER
#else
#	define UCFG_MSC_VERSION 0
#	define UCFG_MSC_FULL_VERSION 0
#endif

#if !defined(_MAC) && (defined(_M_M68K) || defined(_M_MPPC))
#	define _MAC
#endif

#ifdef _M_IX86
#	define UCFG_PLATFORM_IX86 1
#else
#	define UCFG_PLATFORM_IX86 0
#endif

#ifdef _M_X64
#	define UCFG_PLATFORM_X64 1
#else
#	define UCFG_PLATFORM_X64 0
#endif

#define UCFG_CPU_X86_X64 (UCFG_PLATFORM_IX86 || UCFG_PLATFORM_X64)

#define UCFG_PLATFORM_64 UCFG_PLATFORM_X64

#ifndef UCFG_USE_MASM
#	define UCFG_USE_MASM UCFG_CPU_X86_X64
#endif


#ifdef _M_ARM
#	ifndef ARM  //!!!
#		define ARM //!!!
#	endif

#	ifndef _ARM_  //!!!
#		define _ARM_  //!!!
#	endif

#	ifdef _MSC_VER
#		if _MSC_VER < 1600
#			ifndef _WIN32_WCE
#				define _WIN32_WCE 0x420
#			endif
#		else
#			define _CRT_BUILD_DESKTOP_APP 0
#		endif
#	endif
#endif

#ifndef __STDC_VERSION__
#	if UCFG_MSC_VERSION >= 1700
#		define __STDC_VERSION__ 199901L
#	else
#		define __STDC_VERSION__ 1
#	endif
#endif

#ifdef _WIN32_WCE
#	ifndef WINCEOSVER
#		define WINCEOSVER _WIN32_WCE
#	endif


//	#ifndef _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA
//		#define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA
//	#endif
#	define UCFG_WCE 1
#else
#	define UCFG_WCE 0
#endif

#if !defined(_WIN32_WINNT) && !UCFG_WCE
#	define _WIN32_WINNT 0x602
#endif

#define _CORECRT_WIN32_WINNT  _WIN32_WINNT_WINXP	//!!!?

#ifndef _VCRT_WIN32_WINNT
#	define _VCRT_WIN32_WINNT _WIN32_WINNT		//!!!?
#endif

#define NTDDI_WIN7SP1 0x06010001 //!!!?

#ifndef NTDDI_VERSION
#	define NTDDI_VERSION        0x06020000		//  NTDDI_WIN8
#endif

#define _APISET_MINWIN_VERSION 0x200

#define PSAPI_VERSION 1							// to use psapi.dll instead of new kernel32 replacement


#ifndef __SPECSTRINGS_STRICT_LEVEL //!!!
#	define __SPECSTRINGS_STRICT_LEVEL 0
#endif	


#ifdef _M_IX86
#	define _X86_
#endif

#ifdef _M_AMD64
#	define _AMD64_
#endif

#ifdef _UNICODE
#	define UCFG_UNICODE 1
#else
#	define UCFG_UNICODE 0
#endif

#if UCFG_WCE
#	ifndef _UNICODE
#		error ExtLib/CE requires _UNICODE defined
#	endif

#	ifndef UNDER_CE
#		define UNDER_CE _WIN32_WCE
#	endif

#	ifndef WIN32
#		define WIN32
#	endif
	
#	define _CRTAPI1
#	define _CRTAPI2

#endif

#ifndef WDM_DRIVER
#	ifdef NDIS_WDM
#		define WDM_DRIVER
#	endif                    
#endif

#ifdef WDM_DRIVER
#	define UCFG_WDM 1
#else
#	define UCFG_WDM 0
#endif

#ifndef UCFG_EXT_C
#	define UCFG_EXT_C UCFG_WDM
#endif

#if !defined(WIN32) && defined(_WIN32) && !UCFG_WDM && !UCFG_EXT_C
#	define WIN32
#endif

#ifndef UCFG_WIN32
#	ifdef WIN32
#		define UCFG_WIN32 1
#	else
#		define UCFG_WIN32 0
#	endif
#endif

#define UCFG_WIN32_FULL (UCFG_WIN32 && !UCFG_WCE)

#ifndef WINVER
#	define WINVER 0x0600 //!!! 0x400
#endif

#ifndef UCFG_USE_WINDEFS
#	define UCFG_USE_WINDEFS UCFG_WIN32
#endif

#ifndef UCFG_CPP17
#	if defined(__cplusplus) && __cplusplus >= 201700 || (UCFG_MSC_VERSION >= 2000) || (UCFG_GNUC_VERSION >= 411) || (UCFG_CLANG_VERSION >= 400)		//!!!?
#		define UCFG_CPP17 1
#	else
#		define UCFG_CPP17 0
#	endif
#endif

#ifndef UCFG_CPP14
#	if defined(__cplusplus) && __cplusplus >= 201400 || (UCFG_MSC_VERSION >= 1900) || (UCFG_GNUC_VERSION >= 410) || (UCFG_CLANG_VERSION >= 310)	//!!!?
#		define UCFG_CPP14 1
#	else
#		define UCFG_CPP14 UCFG_CPP17
#	endif
#endif

#ifndef UCFG_CPP11
#	if defined(__cplusplus) && __cplusplus > 199711 || defined(__GXX_EXPERIMENTAL_CXX0X__) || (UCFG_MSC_VERSION >= 1600) || UCFG_WCE
#		define UCFG_CPP11 1
#	else
#		define UCFG_CPP11 UCFG_CPP14
#	endif
#endif

#ifndef UCFG_CPP11_ENUM
#	if defined(_MSC_VER) && _MSC_VER<1700
#		define UCFG_CPP11_ENUM 0
#	else
#		define UCFG_CPP11_ENUM UCFG_CPP11
#	endif
#endif

#ifndef UCFG_CPP11_EXPLICIT_CAST
#	if defined(_MSC_VER) && _MSC_VER<=1700 || defined(__GXX_EXPERIMENTAL_CXX0X__) && __GNUC__ == 4 && __GNUC_MINOR__ < 5
#		define UCFG_CPP11_EXPLICIT_CAST 0
#	else
#		define UCFG_CPP11_EXPLICIT_CAST UCFG_CPP11
#	endif
#endif

#ifndef UCFG_CPP11_NULLPTR
#	if defined(_NATIVE_NULLPTR_SUPPORTED)
#		define UCFG_CPP11_NULLPTR 1
#	elif defined(_MSC_VER) && _MSC_VER<1600
#		define UCFG_CPP11_NULLPTR 0
#	elif defined(__GXX_EXPERIMENTAL_CXX0X__) && !defined(__clang__)
#		if __GNUC__ == 4 && __GNUC_MINOR__ <= 5
#			define UCFG_CPP11_NULLPTR 0
#		else
#			define UCFG_CPP11_NULLPTR 1
#		endif
#	else
#		define UCFG_CPP11_NULLPTR UCFG_CPP11
#	endif
#endif

#ifndef UCFG_CPP11_FOR_EACH
#	define UCFG_CPP11_FOR_EACH UCFG_CPP11
#endif

#ifndef UCFG_CPP11_RVALUE
#	if	defined(_MSC_VER) && _MSC_VER<1600
#		define UCFG_CPP11_RVALUE 0
#	else
#		define UCFG_CPP11_RVALUE UCFG_CPP11
#	endif
#endif

#ifndef UCFG_CPP11_OVERRIDE
#	define UCFG_CPP11_OVERRIDE (UCFG_GNUC_VERSION >= 407 || UCFG_MSC_VERSION >= 1600 || (!UCFG_GNUC_VERSION && !UCFG_MSC_VERSION && UCFG_CPP11))
#endif

#ifndef UCFG_CPP14_NOEXCEPT
#	define UCFG_CPP14_NOEXCEPT (UCFG_GNUC_VERSION >= 406 || UCFG_MSC_VERSION >= 1900 || (!UCFG_GNUC_VERSION && !UCFG_MSC_VERSION && UCFG_CPP11))
#endif

#ifndef EXT_NOEXCEPT
#	define EXT_NOEXCEPT noexcept
#endif

#ifndef UCFG_C99_FUNC
#	define UCFG_C99_FUNC (!UCFG_MSC_VERSION || UCFG_MSC_VERSION >= 1900)
#endif

#ifndef UCFG_CPP11_THREAD_LOCAL
#	if (defined(_MSC_VER) && _MSC_VER<=1800) || (defined(__GXX_EXPERIMENTAL_CXX0X__) && __GNUC__ == 4 && __GNUC_MINOR__ <= 6)
#		define UCFG_CPP11_THREAD_LOCAL 0
#	else
#		define UCFG_CPP11_THREAD_LOCAL UCFG_CPP11
#	endif
#endif

#ifndef UCFG_CPP11_HAVE_MUTEX
#	if (!defined(_MSC_VER) || _MSC_VER>=1700) && (!defined(__clang_major__) || __clang_major__>3 || __clang_major__==3 && __clang_minor__>0)
#		define UCFG_CPP11_HAVE_MUTEX 1
#	else
#		define UCFG_CPP11_HAVE_MUTEX 0
#	endif
#endif

#ifndef UCFG_STD_SHARED_MUTEX
#	define UCFG_STD_SHARED_MUTEX UCFG_CPP14
#endif

#ifndef UCFG_STD_DYNAMIC_BITSET
#	define UCFG_STD_DYNAMIC_BITSET UCFG_CPP14 && !(UCFG_MSC_VERSION && UCFG_MSC_VERSION <= 1800) && !(UCFG_CLANG_VERSION && UCFG_CLANG_VERSION <= 305)
#endif

#ifndef UCFG_CPP11_HAVE_REGEX
#	define UCFG_CPP11_HAVE_REGEX (UCFG_GNUC_VERSION >= 410 || UCFG_MSC_VERSION >= 1600)
#endif

#ifndef UCFG_HAVE_STATIC_ASSERT
#	define UCFG_HAVE_STATIC_ASSERT UCFG_CPP11
#endif

#ifndef UCFG_CPP11_HAVE_THREAD
#	if (!defined(_MSC_VER) || _MSC_VER>=1700) && (!defined(__clang_major__) || __clang_major__>3 || __clang_major__==3 && __clang_minor__>0)
#		define UCFG_CPP11_HAVE_THREAD 1
#	else
#		define UCFG_CPP11_HAVE_THREAD 0
#	endif
#endif

#ifndef UCFG_STD_DECIMAL
#	define UCFG_STD_DECIMAL (UCFG_GNUC_VERSION >= 410 || UCFG_MSC_VERSION >= 2000)
#endif

#ifndef UCFG_CPP11_HAVE_CODECVT
#	define UCFG_CPP11_HAVE_CODECVT (UCFG_GNUC_VERSION >= 410 || UCFG_MSC_VERSION >= 1800)
#endif

#ifndef UCFG_STD_SYSTEM_ERROR
#	define UCFG_STD_SYSTEM_ERROR UCFG_CPP11
#endif

#ifndef UCFG_CPP11_BEGIN
#	define UCFG_CPP11_BEGIN (UCFG_CPP14 || UCFG_GNUC_VERSION >= 406 || UCFG_MSC_VERSION >= 1600)
#endif

#ifndef UCFG_STD_EXCHANGE
#	define UCFG_STD_EXCHANGE UCFG_CPP14
#endif

#if !defined(_HAS_CHAR16_T_LANGUAGE_SUPPORT) && UCFG_CPP11
#	define _HAS_CHAR16_T_LANGUAGE_SUPPORT 1
#endif


#ifndef UCFG_STD_FILESYSTEM
#	define UCFG_STD_FILESYSTEM UCFG_CPP14 && !(UCFG_CLANG_VERSION && UCFG_CLANG_VERSION <= 305)
#endif

#ifndef UCFG_STD_IDENTITY
#	define UCFG_STD_IDENTITY (UCFG_MSC_VERSION >= 1500)
#endif


#define WIN9X_COMPAT_SPINLOCK

#ifdef _CPPUNWIND
#	define _HAS_EXCEPTIONS 1
#else
#	define _HAS_EXCEPTIONS 0
#endif

#define _HAS_NAMESPACE 1

#define _ATL_NO_AUTOMATIC_NAMESPACE

#define _ATL_ALLOW_CHAR_UNSIGNED  // to prevent ATL error in VS11

/*!!!R
#ifndef _MSC_VER

#	ifdef __CHAR_UNSIGNED__
#		define _CHAR_UNSIGNED
#	endif

#endif
*/

#define _HAS_TRADITIONAL_STL 1


#ifndef _FILE_OFFSET_BITS
#	define _FILE_OFFSET_BITS 64
#endif


#ifndef _STRALIGN_USE_SECURE_CRT
#	define _STRALIGN_USE_SECURE_CRT 0
#endif

#ifndef UCFG_POOL_THREADS
#	define UCFG_POOL_THREADS 25
#endif

#ifndef UCFG_EH_OS_UNWIND
#	define UCFG_EH_OS_UNWIND (defined _M_X64)
#endif

#define UCFG_EH_PDATA (!defined _M_IX86)

#ifndef UCFG_EH_DIRECT_CATCH
#	define UCFG_EH_DIRECT_CATCH (!UCFG_WCE)
#endif

#if !defined(_MSC_VER) && defined(__GNUC__)
#	define UCFG_GNUC 1
#else
#	define UCFG_GNUC 0
#endif

#if UCFG_WDM && (UCFG_CPU_X86_X64 || defined(_M_ARM))	//!!!?
#	define UCFG_FPU 0
#else
#	define UCFG_FPU 1
#endif

#ifdef _DEBUG
#	define DBG 1
#	define DEBUG 1
#else
#	define DBG 0
#endif

#define _COMPLEX_DEFINED

#ifdef _MSC_VER
#	define HAVE_SNPRINTF 1
#	define HAVE_STRLCPY
#	define HAVE_STRDUP 1
#	define HAVE_VSNPRINTF 1
#	define HAVE_MEMMOVE  1
#	define HAVE_FCNTL_H 1
#	define HAVE_STRSEP
#	define HAVE_SOCKADDR_STORAGE
#	define HAVE_SQLITE3 1
#	define HAVE_LIBGMP 1
#	define HAVE_LIBNTL 1
#	define HAVE_BERKELEY_DB 1
#	define HAVE_JANSSON 1
#endif	// _MSC_VER

#ifndef UCFG_DEFINE_NOMINMAX
#	define UCFG_DEFINE_NOMINMAX 1
#endif

#if	UCFG_DEFINE_NOMINMAX
#	define NOMINMAX					// used in windows.h
#endif

#ifndef UCFG_DEFINE_OLD_NAMES
#	define UCFG_DEFINE_OLD_NAMES 0
#endif


#if UCFG_GNUC_VERSION || UCFG_CLANG_VERSION
#	if defined(_M_X64) || defined(_M_ARM) || defined(_M_MIPS)
#		define __cdecl
#		define _cdecl
#		define __stdcall
#		define _stdcall
#		define __fastcall
#		define _fastcall
#		define __thiscall
#		define _thiscall
#	else
#		ifndef __cdecl
#			define __cdecl  __attribute((__cdecl__))
#		endif

#		ifndef _cdecl
#			define _cdecl __attribute((__cdecl__))
#		endif

#		ifndef __stdcall
#			define __stdcall  __attribute((__stdcall__))
#		endif

#		ifndef _stdcall
#			define _stdcall __attribute((__stdcall__))
#		endif

#		ifndef __fastcall
#			define __fastcall  __attribute((__fastcall__))
#		endif

#		ifndef _fastcall
#			define _fastcall __attribute((__fastcall__))
#		endif

#		ifndef __thiscall
#			define __thiscall  __attribute((__thiscall__))
#		endif

#		ifndef _thiscall
#			define _thiscall __attribute((__thiscall__))
#		endif
#	endif // defined(_M_X64) || defined(_M_ARM) || defined(_M_MIPS)

#	ifndef PASCAL
#		define PASCAL
#	endif
#endif  // UCFG_GNUC_VERSION || UCFG_CLANG_VERSION



